Skip to content

Latest commit

 

History

History
56 lines (43 loc) · 1.89 KB

26. Remove duplicates from Sorted Array.md

File metadata and controls

56 lines (43 loc) · 1.89 KB

Task

Given an integer array nums sorted in non-decreasing order, remove the duplicates in-place such that each unique element appears only once. The relative order of the elements should be kept the same. Then return the number of unique elements in nums.

Consider the number of unique elements of nums to be k, to get accepted, you need to do the following things:

  • Change the array nums such that the first k elements of nums contain the unique elements in the order they were present in nums initially. The remaining elements of nums are not important as well as the size of nums.
  • Return k.

Example 1: Input: nums = [1,1,2] Output: 2, nums = [1,2,_] Explanation: Your function should return k = 2, with the first two elements of nums being 1 and 2 respectively. It does not matter what you leave beyond the returned k (hence they are underscores).

Example 2: Input: nums = [0,0,1,1,1,2,2,3,3,4] Output: 5, nums = [0,1,2,3,4,,,,,_] Explanation: Your function should return k = 5, with the first five elements of nums being 0, 1, 2, 3, and 4 respectively. It does not matter what you leave beyond the returned k (hence they are underscores).

Constraints:

  • 1 <= nums.length <= 3 * 10**4
  • -100 <= nums[i] <= 100
  • nums is sorted in non-decreasing order.

Algorithm

  1. two pointers:
    • i = 1 - current element
    • j = 1 - place for next unique element
  2. iterate by nums
  3. find next unique num
  4. nums[j] = nums[i]
  5. j++

Code

int removeDuplicates(vector<int>& nums) 
{
    std::size_t j = 1;
    
    for(std::size_t i = 1; i < nums.size(); i++)
        if(nums[i] != nums[i - 1])
            nums[j++] = nums[i];
            
    return j;
}

#cs #cpp #leetcode #two_pointers